/*********************************************************************************
**
**   $Id: VendorSelect.cpp,v 1.2 2004/04/03 14:04:53 croftj Exp $
**   Copyright (c) 2004 Joe Croft <joe@croftj.net>
**   
**   This file is part of ah2.
**
**   ah2 is free software; you can redistribute it and/or modify
**   it under the terms of the GNU General Public License as published by
**   the Free Software Foundation; either version 2 of the License, or
**   (at your option) any later version.
**
**   Foobar is distributed in the hope that it will be useful,
**   but WITHOUT ANY WARRANTY; without even the implied warranty of
**   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**   GNU General Public License for more details.
**
**   You should have received a copy of the GNU General Public License
**   along with Foobar; if not, write to the Free Software
**   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**
*********************************************************************************/

#include <qlistbox.h>
#include <qregexp.h>
#include <qsqlquery.h>
#include "VendorSelect.h"

int VendorSelect::getVendor() const
{
   int rv = -1;

   printf("VendorSelect::getVendor(): Enter\n");
   QString aname = currentText();
   QRegExp re(".*:");
   re.setMinimal(true);
   aname.replace(re, "");

   aname.replace(QRegExp("'"), "''");
   QString sql = "select ident from vendors where name = '" + 
                 aname + "'";
   printf("VendorSelect::getVendor(): sql = |%s|\n", (const char*)sql);
   fflush(stdout);
   QSqlQuery q(sql);
   if (q.isActive())
   {
      if (q.next()) 
         rv = q.value(0).toInt();
   }
   printf("VendorSelect::getVendor(): rv = %d\n", rv);
   fflush(stdout);
   printf("VendorSelect::getVendor(): exit\n");
   return(rv);
}

void VendorSelect::setVendor(int a)
{
   QListBoxItem *li;
   QString strIdent, ident;

   printf("VendorSelect::setVendor(): Enter\n");
   strIdent.setNum(a);
   QString sql = "select name from vendors where ident = '" +
                 strIdent + "'";
   printf("VendorSelect::setVendor(): sql = |%s|\n", (const char*)sql);
   QSqlQuery q(sql);
   if (q.isActive())
   {
      if (q.next()) 
         ident = q.value(0).toString();
   }

   li = listBox()->findItem(ident);
   int i = listBox()->index(li);
   listBox()->setSelected(li, true);
   setCurrentItem(i);
   setCurrentText(ident);
   printf("VendorSelect::setVendor(): Setting vendor |%s|, %d\n", (const char*)ident, i);
   fflush(stdout);
}

void VendorSelect::refresh()
{
   int v = getVendor();
   QStringList accList;
   printf("VendorSelect::refresh(): enter\n");
   QString sql = "select ident, name from vendors where active != 'N' order by name";
   printf("VendorSelect::refresh(): sql = |%s|\n", (const char*)sql);
   QSqlQuery q(sql);
   accList += "";
   if (q.isActive())
   {
      while (q.next()) 
      {
         QString p = q.value(0).toString() + ":" + q.value(1).toString();
         printf("VendorSelect::refresh(): Adding vendor |%s|\n", (const char*)p);
         fflush(stdout);
         accList += p;
      }
      clear();
      insertStringList(accList);
   }
   setVendor(v);
   printf("VendorSelect::refresh(): exit\n");
   fflush(stdout);
}
